#include <libnet.h>
#include <pcap.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if_arp.h>
#include <sys/sockio.h>

#define ARP_REQUEST     1
#define ARP_RESPONSE    2
#define ETH_HW_ADDR_LEN 6
#define IP_ADDR_LEN 4

struct  ether_header {
        struct  ether_addr      ether_dhost;
        struct  ether_addr      ether_shost;
        u_short ether_type;
};

struct arp_packet
{
   u_char targ_hw_addr[ETH_HW_ADDR_LEN];
   u_char src_hw_addr[ETH_HW_ADDR_LEN];
   u_short frame_type;
   u_short hw_type;
   u_short prot_type;
   u_char hw_addr_size;
   u_char prot_addr_size;
   u_short op;
   u_char sndr_hw_addr[ETH_HW_ADDR_LEN];
   u_char sndr_ip_addr[IP_ADDR_LEN];
   u_char rcpt_hw_addr[ETH_HW_ADDR_LEN];
   u_char rcpt_ip_addr[IP_ADDR_LEN];
   u_char padding[18];
};

struct arp_info
{
   short op_type;
   char hw_addr_sender[18];
   char hw_addr_rcpt[18];
   char ip_addr_sender[16];
   char ip_addr_rcpt[16];
};

struct arp_info* init_arp_request_packet(char*, char*, struct libnet_link_int*);
int send_arp_packet(struct libnet_link_int*, struct arp_info*, char*);
void receive_arp_packet(pcap_t*, struct arp_info**);
void put_hw_addr(u_char*, char*);
void put_ip_addr(u_char**, char *);
char* get_ip_addr(u_char*);
char* get_hw_addr(u_char*);
int arp_cache_lookup(char*, char*, char**);
void die(const char*);
u_long betole(u_long);


